.586
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

.data

align 16
 ;   num     dq 1152921504606846978    ; 2^60 + 2      64 /  0  Error division by zero
 ;   den     dq                   0    ; 0

 ;   num     dq 1152921504606846978    ; 2^60 + 2      64 /  1  quotient, 0 remainder
 ;   den     dq                   1    ; 1                      Division by one


  num     dq 1152921504606846978    ; 2^60 + 2      64 / 64  quotient, remainder
  den     dq    1125899906842627    ; 2^50 + 3

 ;   num     dq 1152921504606846976    ; 2^60          64 / 64  quotient, 0 remainder
 ;   den     dq    1125899906842624    ; 2^50

 ;   num     dq    1125899906842624    ; 2^50          64 / 64  1 quotient, 0 remainder
 ;   den     dq    1125899906842624    ; 2^50

 ;   num     dq    1125899906842624    ; 2^50          64 / 64  0 quotient, remainder
 ;   den     dq 1152921504606846976    ; 2^60


 ;   num     dq 1152921504606846977    ; 2^60 + 1      64 / 32  quotient, remainder
 ;   den     dq                   8    ; 8

 ;   num     dq 1152921504606846976    ; 2^60          64 / 32  quotient, 0 remainder
 ;   den     dq                   8    ; 8



 ;   num     dq                 101    ; 101           32 /  1  quotient, 0 remainder
 ;   den     dq                   1    ; 1                      Division by one

 ;   num     dq                 101    ; 101           32 / 32  quotient, remainder
 ;   den     dq                   5    ; 5

 ;   num     dq                 100    ; 100           32 / 32  quotient, 0 remainder
 ;   den     dq                   5    ; 5

 ;   num     dq                   5    ; 5             32 / 32  1 quotient, 0 remainder
 ;   den     dq                   5    ; 5

 ;   num     dq                   5    ; 5             32 / 32  0 quotient, remainder
 ;   den     dq                 100    ; 100

  quo     dq                   0
  rem     dq                   0

  quofp   dq                   0
  remfp   dq                   0

  dont    dd 0
  
  szBefore     db  256 dup (0)
  szBeforeFmt  db "%8x %08x Numerator  ",13,10
               db "%8x %08x Denominator",0

;  szBeforeFmt  db "%lx %lx %lx %lx",0    ; quick debugging


  szAfterFp    db  256 dup (0)
  szAfter      db  256 dup (0)
  szAfterFmt   db "%8x %08x Quotient ",13,10
               db "%8x %08x Remainder",0

  szCaption    db "(Unsigned) QWord division",0
  szDivZeroErr db "Would have been division by zero",0

.code
start:
  mov edx, dword ptr num+4
  mov ecx, dword ptr num+0
  mov ebx, dword ptr den+4
  mov eax, dword ptr den+0
  invoke wsprintf, ADDR szBefore, ADDR szBeforeFmt, edx, ecx, ebx, eax  ; num+4, num, den+4, den
  invoke MessageBox, NULL, addr szBefore, addr szCaption, MB_OK


;             handle division by 0
  .if (dword ptr den+0 == 0) && (dword ptr den+4 == 0)
    invoke MessageBox, NULL, addr szDivZeroErr, addr szCaption, MB_OK
    mov dont, 1


;             handle division by 1
  .elseif (dword ptr den+0 == 1) && (dword ptr den+4 == 0)
     mov edx, dword ptr num+4
     mov eax, dword ptr num+0
     mov dword ptr quo+4, edx
     mov dword ptr quo+0, eax
     mov dword ptr rem+4, 0
     mov dword ptr rem+0, 0


;             handle division of 32 bit by 32 bit
;             unneeded, just a case of 64 bit by 32 bit
 ;   .elseif (dword ptr num+0 >= 0) && (dword ptr num+4 == 0) && \
 ;           (dword ptr den+0 >= 2) && (dword ptr den+4 == 0)
 ;      mov ecx, dword ptr den+0
 ;     .if    (dword ptr num+0 == ecx)   ; num == den
 ;        mov dword ptr quo+4, 0
 ;        mov dword ptr quo+0, 1
 ;        mov dword ptr rem+4, 0
 ;        mov dword ptr rem+0, 0
 ;     .elseif (dword ptr num+0 <  ecx)  ; num <  den 
;            mov edx, dword ptr num+4
 ;        mov eax, dword ptr num+0
 ;        mov dword ptr quo+4, 0
 ;        mov dword ptr quo+0, 0
 ;        mov dword ptr rem+4, 0
 ;        mov dword ptr rem+0, eax
 ;     .else                             ; num >  den
;            mov edx, dword ptr num+4
 ;        mov edx, 0
 ;        mov eax, dword ptr num+0
 ;        div ecx
 ;        mov dword ptr quo+4, 0
 ;        mov dword ptr quo+0, eax
 ;        mov dword ptr rem+4, 0
 ;        mov dword ptr rem+0, edx
 ;     .endif


;             handle division of 64 bit by 32 bit
  .elseif (dword ptr num+0 >= 0) && (dword ptr num+4 >= 0) && \  ; != 0
          (dword ptr den+0 >= 2) && (dword ptr den+4 == 0)
    mov ecx, dword ptr den+0
    .if ecx <= dword ptr num+4       ; lo den <= hi num  dwords   ; num >  den  64bits / 32bits
                                     ; 5h 1h / 3h   3h 1h / 3h
;         mov ecx, dword ptr den+0     ; denominator already in ecx
       mov edx, 0
       mov eax, dword ptr num+4
       div ecx
       mov dword ptr quo+4, eax
       mov dword ptr rem+4, 0
;         mov edx, edx               ; remainder from div in edx already edx:eax
       mov eax, dword ptr num+0
;         mov ecx, dword ptr den+0   ; denominator already in ecx
       div ecx
       mov dword ptr quo+0, eax
       mov dword ptr rem+0, edx
                                     ; both  32bits are optional but  NO div used
    .elseif (dword ptr num+0 == ecx) && (dword ptr num+4 == 0)    ; num == den  32bits
       mov dword ptr quo+4, 0
       mov dword ptr quo+0, 1
       mov dword ptr rem+4, 0
       mov dword ptr rem+0, 0
    .elseif (dword ptr num+0 <  ecx) && (dword ptr num+4 == 0)    ; num <  den  32bits
;         mov edx, dword ptr num+4
       mov eax, dword ptr num+0
       mov dword ptr quo+4, 0
       mov dword ptr quo+0, 0
       mov dword ptr rem+4, 0
       mov dword ptr rem+0, eax

    .else                            ; lo den >  hi num  dwords   ; num >  den  xxbits / 32bits
                                     ; 3h 1h / 5h   0h 1h / 5h
                                     ; this can also replace both 32bits tests above
                                     ; at the cost doing a div
;         mov ecx, dword ptr den+0     ; denominator already in ecx
       mov edx, dword ptr num+4
       mov eax, dword ptr num+0
       div ecx
       mov dword ptr quo+4, 0
       mov dword ptr quo+0, eax
       mov dword ptr rem+4, 0
       mov dword ptr rem+0, edx
    .endif


;             handle division of 64 bit by 64 bit
  .elseif (dword ptr num+0 >= 0) && (dword ptr num+4 != 0) && \
          (dword ptr den+0 >= 0) && (dword ptr den+4 != 0)
    mov edx, dword ptr num+4
    mov eax, dword ptr num+0
    .if (edx < dword ptr den+4)  ; _num < den_   0 -> quo, num -> rem
       mov dword ptr quo+4, 0
       mov dword ptr quo+0, 0
       mov dword ptr rem+4, edx
       mov dword ptr rem+0, eax
    .elseif (eax == dword ptr den+0) && (edx == dword ptr den+4)  ; _num == den_
       mov dword ptr quo+4, 0
       mov dword ptr quo+0, 1
       mov dword ptr rem+4, 0
       mov dword ptr rem+0, 0
    .else                        ; _num > den_
       mov edx, 0                ; hi num / hi den    round(lo) quo = hi num / hi den
       mov eax, dword ptr num+4
       mov ecx, dword ptr den+4
       div ecx                   ; hi num / hi den
       mov dword ptr quo+4, 0
       .if (dword ptr den+0 > 0) ; if lo den != 0, round up  hi den
         dec eax
       .endif
       mov dword ptr quo+0, eax  ; lo quo <- eax

       mov ecx, eax              ; lo den * lo quo     rem = num - (den * quo)
       mov edx, 0
       mov eax, dword ptr den+0
       mul ecx
       mov dword ptr rem+4, edx  ; rem = result lo den * lo quo
       mov dword ptr rem+0, eax
       mov ebx, edx              ; hold hi rem
       mov edx, 0                ; temp = hi den * lo quo  + hi rem
       mov eax, dword ptr den+4
       mul ecx
       add eax, ebx
       mov dword ptr rem+4, eax  ; hi rem = hi rem + lo temp
       mov edx, dword ptr num+4  ; rem = num - rem
       mov eax, dword ptr num+0
       sub eax, dword ptr rem+0
       sbb edx, dword ptr rem+4
       mov dword ptr rem+4, edx
       mov dword ptr rem+0, eax
    .endif   
  .endif

 ;   invoke wsprintf, ADDR szBefore, ADDR szBeforeFmt, num+4, num, den+4, den
 ;   invoke MessageBox, NULL, addr szBefore, addr szCaption, MB_OK
 ;   invoke wsprintf, ADDR szAfter,  ADDR szAfterFmt,  quo+4, quo, rem+4, rem
 ;   invoke MessageBox, NULL, addr szAfter, addr szCaption, MB_OK

 ;   mov edx, dword ptr num+4
 ;   mov ecx, dword ptr num+0
 ;   mov ebx, dword ptr den+4
 ;   mov eax, dword ptr den+0
 ;   invoke wsprintf, ADDR szBefore, ADDR szBeforeFmt, edx, ecx, ebx, eax
 ;   invoke MessageBox, NULL, addr szBefore, addr szCaption, MB_OK

  .if dont == 0
    mov edx, dword ptr quo+4
    mov ecx, dword ptr quo+0
    mov ebx, dword ptr rem+4
    mov eax, dword ptr rem+0
    invoke wsprintf, ADDR szAfter,  ADDR szAfterFmt,  edx, ecx, ebx, eax
    invoke MessageBox, NULL, addr szAfter, addr szCaption, MB_OK
  .endif

  finit
  fild qword ptr num    ; load num
  fild qword ptr den    ; load den
  fdiv                  ; quofp = num / den
  fldz                  ; 0
  fadd  st, st(1)       ; copy quofp has 1023.999
  fld1                  ; 1
  fxch                  ; 1 <--> quofp swap spots on stack
  fprem                 ; just the decimal part  0.999
  fxch                  ; swap
  fld1                  ; 1
  fsub                  ; 0 = 1 - 1
  fsub                  ; 0.999 = 0.999 - 0
  fsub                  ; 1023 = 1023.999 - 0.999
  fldz                  ; 0
  fadd  st, st(1)       ; copy quofp has 1023
  fistp qword ptr quofp ; store quofp in qword
  fild  qword ptr den   ; load  den
  fmul                  ; quofp * den
  fild  qword ptr num   ; load  num
  fxch                  ; swap
  fsub                  ; remfp = num - quofp * den
  fistp qword ptr remfp ; store remfp in qword

  mov edx, dword ptr quofp+4
  mov ecx, dword ptr quofp+0
  mov ebx, dword ptr remfp+4
  mov eax, dword ptr remfp+0
  invoke wsprintf, ADDR szAfterFp,  ADDR szAfterFmt,  edx, ecx, ebx, eax
  invoke MessageBox, NULL, addr szAfterFp, addr szCaption, MB_OK


  invoke ExitProcess, NULL
end start